var Alloy = require('/alloy'),
Backbone = Alloy.Backbone,
_ = Alloy._;




function __processArg(obj, key) {
  var arg = null;
  if (obj) {
    arg = obj[key] || null;
  }
  return arg;
}

function Controller() {

  require('/alloy/controllers/' + 'BaseController').apply(this, Array.prototype.slice.call(arguments));
  this.__controllerPath = 'branchUniversal';
  this.args = arguments[0] || {};

  if (arguments[0]) {
    var __parentSymbol = __processArg(arguments[0], '__parentSymbol');
    var $model = __processArg(arguments[0], '$model');
    var __itemTemplate = __processArg(arguments[0], '__itemTemplate');
  }
  var $ = this;
  var exports = {};
  var __defers = {};







  $.__views.window = Ti.UI.createWindow(
  { backgroundColor: "white", navBarHidden: true, id: "window" });

  $.__views.window && $.addTopLevelView($.__views.window);
  $.__views.__alloyId0 = Ti.UI.createView(
  { backgroundColor: "white", top: "0", left: "0", width: "100%", height: "30%", id: "__alloyId0" });

  $.__views.window.add($.__views.__alloyId0);
  $.__views.initBranchButton = Ti.UI.createButton(
  { color: "white", backgroundColor: "darkGray", borderColor: "black", width: "45%", height: "32%", left: "3%", top: "20%", title: "init BUO", id: "initBranchButton" });

  $.__views.__alloyId0.add($.__views.initBranchButton);
  $.__views.registerViewButton = Ti.UI.createButton(
  { color: "white", backgroundColor: "darkGray", borderColor: "black", width: "45%", height: "32%", left: "53%", top: "20%", title: "register View", id: "registerViewButton" });

  $.__views.__alloyId0.add($.__views.registerViewButton);
  $.__views.__alloyId1 = Ti.UI.createView(
  { backgroundColor: "white", top: "30%", left: "0", width: "100%", height: "30%", id: "__alloyId1" });

  $.__views.window.add($.__views.__alloyId1);
  $.__views.generateUrlButton = Ti.UI.createButton(
  { color: "white", backgroundColor: "darkGray", borderColor: "black", left: "60%", width: "35%", height: "32%", top: "20%", title: "generate Url", id: "generateUrlButton" });

  $.__views.__alloyId1.add($.__views.generateUrlButton);
  $.__views.shareSheetButton = Ti.UI.createButton(
  { color: "white", backgroundColor: "darkGray", borderColor: "black", left: "60%", width: "35%", height: "32%", top: "60%", title: "share Sheet", id: "shareSheetButton" });

  $.__views.__alloyId1.add($.__views.shareSheetButton);
  $.__views.aliasTextField = Ti.UI.createTextField(
  { color: "black", backgroundColor: "white", borderColor: "black", borderStyle: "Ti.UI.INPUT_BORDERSTYLE_ROUNDED", width: "55%", height: "32%", left: "3%", top: "20%", id: "aliasTextField" });

  $.__views.__alloyId1.add($.__views.aliasTextField);
  $.__views.__alloyId2 = Ti.UI.createView(
  { backgroundColor: "white", top: "60%", left: "0", width: "100%", height: "30%", id: "__alloyId2" });

  $.__views.window.add($.__views.__alloyId2);
  $.__views.linkTextArea = Ti.UI.createTextArea(
  { color: "black", backgroundColor: "white", borderColor: "black", borderStyle: "Ti.UI.INPUT_BORDERSTYLE_ROUNDED", width: "45%", height: "32%", left: "3%", top: "20%", id: "linkTextArea" });

  $.__views.__alloyId2.add($.__views.linkTextArea);
  $.__views.copyButton = Ti.UI.createButton(
  { color: "white", backgroundColor: "darkGray", borderColor: "black", left: "60%", width: "35%", height: "32%", top: "20%", title: "Copy to Clipboard", id: "copyButton" });

  $.__views.__alloyId2.add($.__views.copyButton);
  $.__views.customEventViewButton = Ti.UI.createButton(
  { color: "white", backgroundColor: "darkGray", borderColor: "black", left: "3%", width: "35%", height: "32%", top: "60%", title: "track custom event", id: "customEventViewButton" });

  $.__views.__alloyId2.add($.__views.customEventViewButton);
  $.__views.standardEventViewButton = Ti.UI.createButton(
  { color: "white", backgroundColor: "darkGray", borderColor: "black", left: "53%", width: "35%", height: "32%", top: "60%", title: "track std event", id: "standardEventViewButton" });

  $.__views.__alloyId2.add($.__views.standardEventViewButton);
  exports.destroy = function () {};




  _.extend($, $.__views);


  var branch = require('io.branch.sdk');
  var branchUniversalObjectProxy;

  var USE_ALERT = true;






  $.initialize = function (params) {
    $.initializeViews();
    $.initializeHandlers();
    $.window.open();
    $.toggleButtons(false);
  };

  $.initializeViews = function () {
    Ti.API.info("start initializeViews");
    $.linkTextArea.setEditable(false);
    $.linkTextArea.setValue("generated link here");
  };

  $.initializeHandlers = function () {
    $.initBranchButton.addEventListener('click', $.onInitBranchButtonClicked);
    $.registerViewButton.addEventListener('click', $.onRegisterViewButtonClicked);
    $.generateUrlButton.addEventListener('click', $.onGenerateUrlButtonClicked);
    $.shareSheetButton.addEventListener('click', $.onShareSheetButtonClicked);
    $.copyButton.addEventListener('click', $.onCopyButtonClicked);
    $.customEventViewButton.addEventListener('click', $.onCustomEventViewButtonClicked);
    $.standardEventViewButton.addEventListener('click', $.onStandardEventViewButtonClicked);
  };






  $.onInitBranchButtonClicked = function () {
    Ti.API.info("inside onInitBranchButtonClicked");
    branchUniversalObjectProxy = branch.createBranchUniversalObject({
      "canonicalIdentifier": "sample-id",
      "title": "Sample",
      "contentDescription": "This is a sample",
      "contentImageUrl": "http://sample-host.com/media/1235904.jpg",
      "contentIndexingMode": "private",
      "contentMetadata": {
        "key": "value",
        "key2": "value2" } });




    branchUniversalObjectProxy.addEventListener("bio:generateShortUrl", $.onGenerateUrlFinished);
    branchUniversalObjectProxy.addEventListener("bio:shareChannelSelected", $.onShareChannelSelected);

    if (true) {
      branchUniversalObjectProxy.addEventListener("bio:shareLinkDialogLaunched", $.onShareLinkDialogLaunched);
      branchUniversalObjectProxy.addEventListener("bio:shareLinkDialogDismissed", $.onShareLinkDialogDismissed);
      branchUniversalObjectProxy.addEventListener("bio:shareLinkResponse", $.onShareLinkResponse);
    }

    $.toggleButtons(true);

    showData({ "init BUO": "success" });
  };

  $.onRegisterViewButtonClicked = function () {
    Ti.API.info("inside onRegisterViewButtonClicked");
    branchUniversalObjectProxy.registerView();
    showData({ "registerView": "success" });
  };

  $.onCustomEventViewButtonClicked = function () {
    Ti.API.info("inside onCustomEventViewButtonClicked");
    var eventName = "Custom";
    branchUniversalObjectProxy.setBranchEvent(
    eventName,
    {
      "affiliation": "sample-affiliation",
      "coupon": "sample-coupon",
      "currency": "USD",
      "description": "sample-description",
      "shipping": 10.2,
      "tax": 8.5,
      "revenue": 100.56,
      "transactionID": "abc123",
      "searchQuery": "sample-search",
      "contentMetadata": {
        "Custom_Event_Property_Key1": "Custom_Event_Property_val1",
        "Custom_Event_Property_Key2": "Custom_Event_Property_val2" } });



    showData({ "customEventView": "success" });
  };

  $.onStandardEventViewButtonClicked = function () {
    Ti.API.info("inside onStandardEventViewButtonClicked");
    var eventName = "PURCHASE";
    branchUniversalObjectProxy.setBranchEvent(
    eventName,
    {
      "affiliation": "sample-affiliation",
      "coupon": "sample-coupon",
      "currency": "USD",
      "description": "sample-description",
      "shipping": 10.2,
      "tax": 8.5,
      "revenue": 100.56,
      "transactionID": "abc123",
      "searchQuery": "sample-search",
      "contentMetadata": {
        "Custom_Event_Property_Key1": "Custom_Event_Property_val1",
        "Custom_Event_Property_Key2": "Custom_Event_Property_val2" } });



    showData({ "standardEventView": "success" });
  };

  $.onGenerateUrlButtonClicked = function () {
    Ti.API.info("inside onGenerateUrlButtonClicked");
    branchUniversalObjectProxy.generateShortUrl({
      "feature": "sample-feature",
      "channel": "sample-channel",
      "stage": "sample-stage",
      "duration": 1 },
    {
      "$desktop_url": "http://desktop_url.com" },
    function (res) {
      Ti.API.info('Generated Short URL');
      Ti.API.info(res);
      $.linkTextArea.setValue(res["generatedLink"]);
    });
  };

  $.onGenerateUrlFinished = function (data) {
    Ti.API.info("inside onGenerateUrlFinished");
    Ti.API.info("GenerateUrlFinished: " + data["generatedLink"]);
    $.linkTextArea.setValue(data["generatedLink"]);
  };

  $.onShareSheetButtonClicked = function () {
    try {
      Ti.API.info("inside onShareSheetButtonClicked");
      branchUniversalObjectProxy.showShareSheet({
        "feature": "sample-feature",
        "channel": "sample-channel",
        "stage": "sample-stage",
        "duration": 1 },
      {
        "$desktop_url": "http://desktop-url.com",
        "$email_subject": "This is a sample subject",
        "$email_body": "This is a sample body" });

    } catch (e) {
      alert(e.message);
    }

  };

  $.onShareLinkDialogLaunched = function (data) {
    try {
      Ti.API.info("inside onShareLinkDialogLaunched");
    } catch (e) {
      alert(e.message);
    }
  };

  $.onShareLinkDialogDismissed = function (data) {
    Ti.API.info("inside onShareLinkDialogDismissed");
  };

  $.onShareLinkResponse = function (data) {
    try {
      Ti.API.info("inside onShareLinkResponse");
    } catch (e) {
      alert(e.message);
    }
  };

  $.onShareChannelSelected = function (data) {
    Ti.API.info("inside onShareChannelSelected");
  };

  $.onCopyButtonClicked = function () {
    Ti.API.info("inside onCopyButtonClicked");
    Ti.UI.Clipboard.clearText();
    Ti.UI.Clipboard.setText($.linkTextArea.getValue());
  };






  $.toggleButtons = function (enable) {
    $.registerViewButton.enabled = enable;
    $.generateUrlButton.enabled = enable;
    $.shareSheetButton.enabled = enable;
  };

  function showData(data) {
    Ti.API.info("start showData");

    if (USE_ALERT) {
      var dict = {};
      for (key in data) {
        if (key != "type" && key != "source" && key != "bubbles" && key != "cancelBubble") {
          dict[key] = data[key];
        }
      }

      if (true) {
        alert(JSON.stringify(dict));
      } else if (false) {
        var dialog = Ti.UI.createAlertDialog({
          title: "Result:",
          message: "" + JSON.stringify(dict),
          buttonNames: ["OK"] });

        dialog.show();
      }
    } else {
      for (key in data) {
        if (key != "type" && key != "source" && key != "bubbles" && key != "cancelBubble" && data[key] != null) {
          Ti.API.info(key + data["key"]);
        }
      }
    }
  }

  $.initialize();









  _.extend($, exports);
}

module.exports = Controller;